 #include <string.h>                    
 #include <stdio.h>     
 #include <stdlib.h>  
 #include <ctype.h>     
 #include <time.h>      
 #include <cmqc.h>  
 #include <sys/types.h>
 #include <unistd.h>
 #include <sys/time.h>

 int i;
 int j;
 int rc;
 int  MsgNumber;
 int  DeadQOpen;
 int  LogQOpen;
 int  NotDone;

 char cReason      [5];
 char DateTime    [20];
 char Hostname    [80];
 char sPID        [20];
 char sUID        [20];
 char Errmsg      [80];

 char cCurTime    [17];
 char ErrorMsg   [200];

 char Char_p  = 'p';
 char Char_r  = 'r';
 char Char_P  = 'P';
 char Char_R  = 'R';

 char Switch             [2];
 char PutTime            [7];
 char PutDate            [9];
 char GetMsgType         [7];
 char DeadFormat         [8];
 char PutApplName       [29];
 char DestQName         [49];
 char DestQMgrName      [49];
 char DeadReplyQName    [49];
 char DeadReplyQMgrName [49];
 char QMName            [49];
 char buffer       [1000000];    
 char newbuffer    [1000000];    

 long DeadReason;
 long DeadPriority;  
 long DeadPersistence; 
 long DeadExpiry;
 long DeadMsgType;
 long DeadMsgFlags;
 long DeadMsgSeqNumber;

 int  SendErrorMsg      (void);
 int  GetHostname       (void);
 int  OpenQueues        (void);
 int  ConnectQMGR       (void);

 void CloseQueues       (void);
 void DisconnectQMGR    (void);
 void WriteErrorToFile  (void);
 void SetDateTime       (void);
 void getPID            (void);
 void getUID            (void);

 void InitErrorMsg (int Severity,long MQreason,char *errmsg,int SendMsgAlso);

 MQOD     od = {MQOD_DEFAULT};    /* Object Descriptor             */
 MQMD     md = {MQMD_DEFAULT};    /* Message Descriptor            */
 MQGMO   gmo = {MQGMO_DEFAULT};   /* get message options           */
 MQPMO   pmo = {MQPMO_DEFAULT};   /* put message options           */

 MQHCONN  Hcon;           
 MQHOBJ   HErrorMsg;           
 MQHOBJ   HDeadMsg;           
 MQLONG   O_options;         
 MQLONG   C_options;         
 MQLONG   CompCode;   
 MQLONG   OpenCode;          
 MQLONG   Reason;   
 MQLONG   CReason;   
 MQLONG   DReason;   
 MQLONG   buflen;             
 MQLONG   messlen;

 MQDLH  *dlh;

 MQBYTE24  DeadMsgId;    
 MQBYTE24  DeadGroupId;    
 MQBYTE24  DeadCorrelId; 

 FILE *Report = NULL;
 FILE *ErrorLog = NULL;

 int main(int argc, char **argv)
 {
    rc = 0;
	rc = GetHostname ();
	if(rc)
	{
 	   strcpy(Errmsg,"1> DeadLetterHandler Exiting");
	   /* (severity,mqrc,error text */
       InitErrorMsg (6,0,Errmsg,0);
       return(0);
	}

    getPID ();
    getUID ();

    if (argc != 2)
    {
       printf("DeadLetterHandler requires a parameter\n");
       printf("Format:\n\n");
       printf("   Switch r will generate a DLH.Report\n");
       printf("   Switch p will move the messages to the original destination queue\n");
 
	   Errmsg[0] = '\0';
 	   strcat(Errmsg,"2> DeadLetterHandler is missing parameters, ");
 	   strcat(Errmsg,"Switch r creats a report, Switch p processes the messages. ");
	   /* (severity,mqrc,error text */
       InitErrorMsg (6,0,Errmsg,0);
       return(0);
    }

    memset (Switch,'\0',sizeof(Switch));
    strncpy(Switch, argv[1],1);

    if((Switch[0] != Char_p) &&
	   (Switch[0] != Char_r) &&
	   (Switch[0] != Char_P) &&
  	   (Switch[0] != Char_R))
    {
       printf("DeadLetterHandler requires a parameter\n");
       printf("Format:\n\n");
       printf("   Switch r will generate the file, DLH.REPORT \n");
       printf("   Switch p will move the messages to the original destination queue\n");
 
	   Errmsg[0] = '\0';
 	   strcat(Errmsg,"3> DeadLetterHandler is missing parameters, ");
 	   strcat(Errmsg,"Switch r creats a report, Switch p processes the messages. ");
	   /* (severity,mqrc,error text */
       InitErrorMsg (6,0,Errmsg,0);
       return(0);
    }

    rc = 0;
    rc = ConnectQMGR();  
    if(rc)
	{
 	   strcpy(Errmsg,"4> DeadLetterHandler Exiting");
	   /* (severity,mqrc,error text,delivery */
       InitErrorMsg (6,0,Errmsg,0);
       return(0);
	}

	rc = 0;
	rc = OpenQueues ();
    if(rc)
	{
 	   strcpy(Errmsg,"5> DeadLetterHandler Exiting");
	   /* (severity,mqrc,error text,delivery */
       InitErrorMsg (6,0,Errmsg,0);
	   CloseQueues ();
       DisconnectQMGR ();
       return(0);
	}

    if(!(Report = fopen("DLH.REPORT","w"))) 
	{
	   printf("Unable to Open file DLH.REPORT\n");
 	   strcpy(Errmsg,"6> Unable to open file DLH.REPORT, Alert Operations ");
	   /* (severity,mqrc,error text,delivery */
       InitErrorMsg (6,0,Errmsg,1);
	   CloseQueues ();
       DisconnectQMGR ();
	   return (0);
	}

    if((Switch[0] == Char_P) || (Switch[0] == Char_p))
    {
       printf("\n\nProcessing the messages \n\n\n");
       Switch[0] =  Char_p;
	   Errmsg[0] = '\0';
 	   strcat(Errmsg,"7> DeadLetterHandler is Processing the messages ");
	   /* (severity,mqrc,error text */
       InitErrorMsg (0,0,Errmsg,1);
    }

    if((Switch[0] == Char_R) || (Switch[0] == Char_r))
    {
       printf("\n\nCreating a report, DLH.REPORT \n\n\n");
       Switch[0] =  Char_r;
	   Errmsg[0] = '\0';
 	   strcat(Errmsg,"8> DeadLetterHandler is creating the DLH.REPORT file ");
	   /* (severity,mqrc,error text */
       InitErrorMsg (0,0,Errmsg,1);
    }

    MsgNumber = 0;

	NotDone = 1;
    
	while (NotDone)
    {
       buflen = sizeof(buffer) - 1;    
       memset(buffer,           '\0', sizeof(buffer));
       memset(newbuffer,        '\0', sizeof(newbuffer));
       memset(DestQName,        '\0', sizeof(DestQName));
       memset(DestQMgrName,     '\0', sizeof(DestQMgrName));
       memset(PutApplName,      '\0', sizeof(PutApplName));
       memset(PutTime,          '\0', sizeof(PutTime));
       memset(PutDate,          '\0', sizeof(PutDate));
       memset(DeadReplyQName,   '\0', sizeof(DeadReplyQName));
       memset(DeadReplyQMgrName,'\0', sizeof(DeadReplyQMgrName));

       if(Switch[0] == Char_r)   
	      gmo.Options = MQGMO_NO_WAIT + MQGMO_BROWSE_NEXT;

	   if(Switch[0] == Char_p)  
		  gmo.Options = MQGMO_NO_WAIT + MQGMO_SYNCPOINT; 
	   	
	   gmo.Version = MQGMO_VERSION_2;
	   md.Version  = MQMD_VERSION_2; 

       memcpy(md.MsgId,    MQMI_NONE, sizeof(md.MsgId));
       memcpy(md.CorrelId, MQCI_NONE, sizeof(md.CorrelId));

       md.Encoding       = MQENC_NATIVE;
       md.CodedCharSetId = MQCCSI_Q_MGR;

       MQGET(Hcon,      
             HDeadMsg,      
             &md,       
             &gmo,      
             buflen,    
             buffer,    
             &messlen,  
             &CompCode,      
             &Reason);       

	   switch (Reason)
	   {           
		 case MQRC_NONE: 
            strncpy(DeadReplyQName,   md.ReplyToQ,    MQ_Q_NAME_LENGTH);
            strncpy(DeadReplyQMgrName,md.ReplyToQMgr, MQ_Q_MGR_NAME_LENGTH);
            strncpy(DeadFormat,       md.Format,      MQ_FORMAT_LENGTH);

            memcpy(DeadGroupId,  md.GroupId,  sizeof(DeadGroupId));
            memcpy(DeadCorrelId, md.CorrelId, sizeof(DeadCorrelId));
			memcpy(DeadMsgId,    md.MsgId,    sizeof(DeadMsgId));
            
			DeadPriority     = md.Priority;  
            DeadPersistence  = md.Persistence; 
            DeadMsgType      = md.MsgType;
            DeadMsgFlags     = md.MsgFlags;
            DeadExpiry       = md.Expiry;
            DeadMsgSeqNumber = md.MsgSeqNumber;
		 break;                                         

		 case MQRC_NO_MSG_AVAILABLE:
			NotDone = 0;
		 break;                                         

		 case MQRC_TRUNCATED_MSG_ACCEPTED: 
            messlen = buflen;			 
            strncpy(DeadReplyQName,   md.ReplyToQ,    MQ_Q_NAME_LENGTH);
            strncpy(DeadReplyQMgrName,md.ReplyToQMgr, MQ_Q_MGR_NAME_LENGTH);
            strncpy(DeadFormat,       md.Format,      MQ_FORMAT_LENGTH);

            memcpy(DeadGroupId,  md.GroupId,  sizeof(DeadGroupId));
            memcpy(DeadCorrelId, md.CorrelId, sizeof(DeadCorrelId));
			memcpy(DeadMsgId,    md.MsgId,    sizeof(DeadMsgId));
            
			DeadPriority     = md.Priority;  
            DeadPersistence  = md.Persistence; 
            DeadMsgType      = md.MsgType;
            DeadMsgFlags     = md.MsgFlags;
            DeadExpiry       = md.Expiry;
            DeadMsgSeqNumber = md.MsgSeqNumber;
		 break;                                         
	 
		 default:
			NotDone = 0;
			strcpy(Errmsg,"9> MQGET FAILURE, Queue = SYSTEM.DEAD.LETTER.QUEUE ");
			/* (severity,mqrc,error text,delivery */
			InitErrorMsg (6,Reason,Errmsg,1);
		 break;                                                                
	   } /* end of switch */
	   
       if(NotDone)
	   {
	      /* put the DLH message */
		  MsgNumber += 1;  
		  dlh =  (MQDLH *)buffer;

		  strncpy(DestQName,   dlh->DestQName,48);
		  strncpy(DestQMgrName,dlh->DestQMgrName,48);
		  strncpy(PutApplName, dlh->PutApplName,28);
		  strncpy(PutTime,     dlh->PutTime,6);
		  strncpy(PutDate,     dlh->PutDate,8);
		  DeadReason =         dlh->Reason;

	      if (Switch[0] == Char_r) 
		  {
			 if(memcmp(MQDLH_STRUC_ID,dlh->StrucId,4) == 0)
			 {
			   fprintf(Report,"START OF MESSAGE NUMBER %d\n",MsgNumber);
			   fprintf(Report,"   MsgType = %ld\n",DeadMsgType);
			   fprintf(Report,"   Destination Queue Name  = %s\n",DestQName);
			   fprintf(Report,"   Destination QMgr  Name  = %s\n",DestQMgrName);
			   fprintf(Report,"   Sending Applicat  Name  = %s\n",PutApplName);
			   fprintf(Report,"   Time Sent               = %s     (hhmmss)\n",PutTime);
			   fprintf(Report,"   Date Sent               = %s   (yyyymmdd)\n",PutDate);
			   fprintf(Report,"   Delivery Failure Reason = %ld\n",DeadReason);
	
               fprintf(Report,"   DeadReplyQName    = %s\n",DeadReplyQName);
               fprintf(Report,"   DeadReplyQMgrName = %s\n",DeadReplyQMgrName);
               fprintf(Report,"   DeadFormat        = %s\n",DeadFormat);
         
		       fprintf(Report,"   DeadPriority     = %ld \n",DeadPriority);  
               fprintf(Report,"   DeadPersistence  = %ld \n",DeadPersistence); 
               fprintf(Report,"   DeadMsgType      = %ld \n",DeadMsgType);
               fprintf(Report,"   DeadMsgFlags     = %ld \n",DeadMsgFlags);
               fprintf(Report,"   DeadExpiry       = %ld \n",DeadExpiry);
               fprintf(Report,"   DeadMsgSeqNumber = %ld \n",DeadMsgSeqNumber);
			   fprintf(Report,"END OF MESSAGE %d \n\n",MsgNumber);
			 }
			 else  /* we have a non DLH formatted message */
			 {
			   fprintf(Report,"START OF MESSAGE NUMBER %d\n",MsgNumber);
			   fprintf(Report,"   Msg Number %d IS NOT a known format!!\n",MsgNumber);
			   fprintf(Report,"   Msg Number %d will be deleted when Deadq is executed with the P parameter\n",MsgNumber);
			   fprintf(Report,"END OF MESSAGE %d \n\n",MsgNumber);
			 }
		  }

		  if (Switch[0] == Char_p)    
		  {
			 if(memcmp(MQDLH_STRUC_ID,dlh->StrucId,4) == 0)
			 {
			    fprintf(Report,"START OF MESSAGE NUMBER %d\n",MsgNumber);
			    fprintf(Report,"   MsgType = %ld\n",DeadMsgType);
			    fprintf(Report,"   Destination Queue Name  = %s\n",DestQName);
			    fprintf(Report,"   Destination QMgr  Name  = %s\n",DestQMgrName);
			    fprintf(Report,"   Sending Applicat  Name  = %s\n",PutApplName);
			    fprintf(Report,"   Time Sent               = %s     (hhmmss)\n",PutTime);
			    fprintf(Report,"   Date Sent               = %s   (yyyymmdd)\n",PutDate);
			    fprintf(Report,"   Delivery Failure Reason = %ld\n",DeadReason);
	
                fprintf(Report,"   DeadReplyQName    = %s\n",DeadReplyQName);
                fprintf(Report,"   DeadReplyQMgrName = %s\n",DeadReplyQMgrName);
                fprintf(Report,"   DeadFormat        = %s\n",DeadFormat);
         
		        fprintf(Report,"   DeadPriority     = %ld \n",DeadPriority);  
                fprintf(Report,"   DeadPersistence  = %ld \n",DeadPersistence); 
                fprintf(Report,"   DeadMsgType      = %ld \n",DeadMsgType);
                fprintf(Report,"   DeadMsgFlags     = %ld \n",DeadMsgFlags);
                fprintf(Report,"   DeadExpiry       = %ld \n",DeadExpiry);
                fprintf(Report,"   DeadMsgSeqNumber = %ld \n",DeadMsgSeqNumber);

			    memcpy(md.MsgId,    DeadMsgId,    sizeof(md.MsgId));                           
			    memcpy(md.CorrelId, DeadCorrelId, sizeof(md.CorrelId));                     
			    memcpy(md.GroupId,  DeadGroupId,  sizeof(md.GroupId));                     

			    strncpy(md.ReplyToQ,   DeadReplyQName,    MQ_Q_NAME_LENGTH);
			    strncpy(md.ReplyToQMgr,DeadReplyQMgrName, MQ_Q_MGR_NAME_LENGTH);

                strncpy(md.Format,MQFMT_NONE,MQ_FORMAT_LENGTH);
			    md.Encoding       = dlh->Encoding ;
			    md.CodedCharSetId = dlh->CodedCharSetId ;
			    md.Priority       = DeadPriority;
			    md.Persistence    = DeadPersistence;
			    md.MsgType        = DeadMsgType;
			    md.MsgFlags       = DeadMsgFlags;
			    md.Expiry         = DeadExpiry;
			    md.MsgSeqNumber   = DeadMsgSeqNumber;

			    pmo.Options    = MQPMO_SYNCPOINT
			    			   + MQPMO_FAIL_IF_QUIESCING;

			    pmo.Version    = MQPMO_VERSION_2;
			    md.Version     = MQMD_VERSION_2; 	

                strncpy(od.ObjectName,    DestQName,    MQ_Q_NAME_LENGTH);
                strncpy(od.ObjectQMgrName,DestQMgrName, MQ_Q_MGR_NAME_LENGTH);
                
				/* remove dlh from the message */
                printf("**** Altering a message ******\n");

                j = 172;
               
			    for(i=0;i<1000000;i++) 
				{
			       newbuffer[i] = buffer[j];
			       j++;
				}	

			    messlen = messlen - 172;
  
			    MQPUT1(Hcon,            
			   	      &od,        
					  &md,               
					  &pmo,                
					  messlen,           
					  newbuffer,        
					  &CompCode,         
					  &Reason);           

			    if(Reason != MQRC_NONE) 
				{   
			       fprintf(Report,"   MQPUT Failed Reason Code is %d\n",Reason);
			       fprintf(Report,"   Rolling back message!!\n");
	   		   
			       MQBACK(Hcon,  
					      &CompCode, 
					      &Reason);  
			   
			       fprintf(Report,"   MQBACK MQRC = %ld\n",Reason);
			   
			       NotDone = 0; /* breaks us out of loop */
			       Errmsg[0] = '\0';
			       strcat(Errmsg,"10> MQPUT1 FAILURE, Queue = ");
			       strcat(Errmsg,DestQName);
			       /* (severity,mqrc,error text,delivery */
			       InitErrorMsg (6,Reason,Errmsg,1);
				}
			    else
				{   
			       fprintf(Report,"   MQPUT Successful!! \n");
			
			       MQCMIT(Hcon,            
					      &CompCode,       
					      &Reason);       
			   
			       fprintf(Report,"   MQCMIT MQRC = %ld\n",Reason);
				}

			    fprintf(Report,"END PROCESSING MESSAGE -%d-\n",MsgNumber);
			 
			 }
			 else
			 {
			    /* throw away the message */
				fprintf(Report,"   Undesired MsgType\n");
				fprintf(Report,"   Msg Number %d has now been deleted\n",MsgNumber);
				MQCMIT(Hcon,            
		 		  	   &CompCode,       
					   &Reason);       
			    fprintf(Report,"   MQCMIT MQRC = %ld\n",Reason);
			    fprintf(Report,"END OF MESSAGE %d\n\n",MsgNumber);
			 }
		  }
	   }     /* end if(NotDone)     */
   }     /* end while (NotDone) */

   if(Switch[0] == Char_r)
	  fprintf(Report,"\n  DEAD LETTER REPORT COMPLETED\n");
   else
      fprintf(Report,"\n  DEAD LETTER PROCESSOR COMPLETED\n");

   if(Report != NULL)                                                         
      fclose(Report); 

   CloseQueues ();
   DisconnectQMGR ();
   return(0);
 }

 int SendErrorMsg (void)
 {
	int Failure;

	Failure = 0;
	md.MsgFlags = MQMF_NONE;
	memcpy(md.GroupId, MQGI_NONE, sizeof(md.GroupId));
    memcpy(md.MsgId,MQMI_NONE,sizeof(md.MsgId));
    memcpy(md.CorrelId,MQCI_NONE,sizeof(md.CorrelId));
    messlen = strlen(ErrorMsg);

    md.Expiry   = MQEI_UNLIMITED;
    md.Version  = MQMD_VERSION_2; 
    pmo.Version = MQPMO_VERSION_2;

    md.Persistence = MQPER_NOT_PERSISTENT;
    pmo.Options    = MQPMO_NO_SYNCPOINT
                   + MQPMO_FAIL_IF_QUIESCING;

    MQPUT(Hcon,            
          HErrorMsg,        
          &md,               
          &pmo,                
          messlen,           
          ErrorMsg,        
          &CompCode,         
          &Reason);           

    if(Reason != MQRC_NONE)
	{
	   Failure = 1;
	   Errmsg[0] = '\0';
  	   strcat(Errmsg,"64> MQPUT FAILURE, Queue = LOGGING ");
	   /* (severity,mqrc,error text,delivery */
	   InitErrorMsg (6,Reason,Errmsg,0);
	}

	return(Failure);
 }

 void WriteErrorToFile (void)
 {
	if(!(ErrorLog = fopen("/abra/mqdist/logs/DLH.ERROR","a"))) 
         printf("Could not open /abra/mqdist/logs/DLH.ERROR\n");
    else
	{
         fprintf(ErrorLog,"%s\n",ErrorMsg);
         if(ErrorLog != NULL)                                                         
            fclose(ErrorLog); 
	}
 }

   void SetDateTime (void)
  {
	 struct tm   *StartTimePtr,TempTime;
     time_t      StartTime;

     memset(DateTime,'\0',sizeof(DateTime));

     StartTime = time(NULL);
     StartTimePtr = localtime(&StartTime);

     TempTime=*StartTimePtr;
     strftime(DateTime, 20, "%m/%d/%Y %H:%M:%S", &TempTime);
  }

  void getPID (void)
  { 
     char string [20];
     int PID;
     PID=getpid();
     sprintf(string,"%d",PID);
     strcpy(sPID,string);
  }

  void getUID (void)
  {
     char string [20];
     int UID;
     UID=getuid();
     sprintf(string,"%d",UID);
     strcpy(sUID,string);
  }

  int GetHostname (void)
  {
     int rc=0;
     rc = gethostname(Hostname, sizeof(Hostname));
	 return(rc);
  }

  void InitErrorMsg (int Severity,long MQreason,char *errmsg,int SendMsgAlso)
  {
     char creason   [5];
     char cSeverity [2]; 

     memset(cSeverity,'\0',sizeof(cSeverity));
     sprintf(cSeverity, "%d",Severity);

     memset(creason,'\0',sizeof(creason));
     sprintf(creason, "%ld",MQreason);

     SetDateTime ();
	 ErrorMsg[0] = '\0';                                                
	 strcat(ErrorMsg,DateTime);
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,Hostname);
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,sUID);
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,sPID);
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,"MQ");
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,"1.0");
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,"1");
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,cSeverity);
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,"distributor");
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,creason);
   	 strcat(ErrorMsg," | ");
  	 strcat(ErrorMsg,errmsg);

     WriteErrorToFile ();

     if(SendMsgAlso == 1) 	 
        SendErrorMsg();
  }

 int OpenQueues (void)
 {
	int OpenFailed;
 
	DeadQOpen  = 0;
    LogQOpen   = 0;
	OpenFailed = 0;

    /* Open the SYSTEM.DEAD.LETTER.QUEUE for gets */

    strcpy(od.ObjectName,"SYSTEM.DEAD.LETTER.QUEUE");

    O_options = MQOO_INPUT_AS_Q_DEF   
              + MQOO_FAIL_IF_QUIESCING + MQOO_BROWSE; 
    MQOPEN(Hcon,                      
           &od,                      
           O_options,                
           &HDeadMsg,                     
           &CompCode,                 
           &Reason);                  

    if (Reason != MQRC_NONE)
    {
       strcpy(Errmsg,"6> MQOPEN FAILURE, Queue = SYSTEM.DEAD.LETTE.QUEUE ");
       /* (severity,mqrc,error text,delivery */
       InitErrorMsg (6,Reason,Errmsg,0);
       OpenFailed = 1;
    }
    else
	   DeadQOpen = 1;

    /* Open the Error Message Queue for puts */

    strcpy(od.ObjectName,"LOGGING");

    O_options = MQOO_OUTPUT          
              + MQOO_FAIL_IF_QUIESCING; 
    MQOPEN(Hcon,                     
          &od,                       
          O_options,                 
          &HErrorMsg,                
          &OpenCode,                  
          &Reason);                  

    if (Reason != MQRC_NONE)
    {
       strcpy(Errmsg,"12> MQOPEN FAILURE, Error Logging Queue");
       /* (severity,mqrc,error text,delivery */
       InitErrorMsg (6,Reason,Errmsg,0);
       OpenFailed = 1;
    }
	else
       LogQOpen = 1;

	return (OpenFailed);
 }

 void CloseQueues (void)
 {
    if(DeadQOpen)
    {  
	  C_options = 0;    
      MQCLOSE(Hcon,     
            &HDeadMsg,  
            C_options,
            &CompCode,  
            &Reason);   

      if(Reason != MQRC_NONE)
      {
         strcpy(Errmsg,"13> MQCLOSE FAILURE, Queue = SYSTEM.DEAD.LETTER.QUEUE ");
         /* (severity,mqrc,error text,delivery */
         InitErrorMsg (6,Reason,Errmsg,1);
      }	  
	}

    if(LogQOpen)
    {  
	  C_options = 0;    
      MQCLOSE(Hcon,     
            &HErrorMsg,  
            C_options,
            &CompCode,  
            &Reason);   

      if(Reason != MQRC_NONE)
      {
         strcpy(Errmsg,"13> MQCLOSE FAILURE, Queue = LOGGING ");
         /* (severity,mqrc,error text,delivery */
         InitErrorMsg (6,Reason,Errmsg,1);
      }	  
	}
 }


 void DisconnectQMGR (void)
 {

    if(CReason == MQRC_NONE)
	{
       MQDISC(&Hcon,       /* connection handle            */
              &CompCode,   /* completion code              */
              &DReason);   /* reason code                  */

       if(DReason != MQRC_NONE)
	   {
         strcpy(Errmsg,"16> MQDISC FAILURE, Default Queue Manager");
         /* (severity,mqrc,error text,delivery */
         InitErrorMsg (6,DReason,Errmsg,0);
	   }
	}
 }

 int ConnectQMGR    (void)
 {
    int ConnectFailure = 0;

	QMName[0] = 0;                 /* default */

    MQCONN(QMName,                 /* queue manager                  */
          &Hcon,                   /* connection handle              */
          &CompCode,               /* completion code                */
          &CReason);               /* reason code                    */

    if (CReason != MQRC_NONE)
    {
       strcpy(Errmsg,"17> MQCONN FAILURE, Default Queue Manager");
       /* (severity,mqrc,error text,delivery */
       InitErrorMsg (6,CReason,Errmsg,0);
	   ConnectFailure = 1;
    }
    return(ConnectFailure);
 }
